diff --git a/third_party/rust/libc/src/lib.rs b/third_party/rust/libc/src/lib.rs
index 366ccff1714a..b6b5cdb1618c 100644
--- a/third_party/rust/libc/src/lib.rs
+++ b/third_party/rust/libc/src/lib.rs
@@ -8,281 +8,298 @@
 // option. This file may not be copied, modified, or distributed
 // except according to those terms.
 
 //! Crate docs
 
 #![allow(bad_style, overflowing_literals, improper_ctypes)]
 #![crate_type = "rlib"]
 #![crate_name = "libc"]
-#![cfg_attr(dox, feature(no_core, lang_items))]
-#![cfg_attr(dox, no_core)]
+#![cfg_attr(cross_platform_docs, feature(no_core, lang_items, const_fn))]
+#![cfg_attr(cross_platform_docs, no_core)]
 #![doc(html_logo_url = "https://www.rust-lang.org/logos/rust-logo-128x128-blk-v2.png",
        html_favicon_url = "https://doc.rust-lang.org/favicon.ico")]
 
 #![cfg_attr(all(target_os = "linux", target_arch = "x86_64"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-unknown-linux-gnu"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-unknown-linux-gnu"
 ))]
 #![cfg_attr(all(target_os = "linux", target_arch = "x86"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/i686-unknown-linux-gnu"
+    html_root_url = "https://rust-lang.github.io/libc/i686-unknown-linux-gnu"
 ))]
 #![cfg_attr(all(target_os = "linux", target_arch = "arm"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/arm-unknown-linux-gnueabihf"
+    html_root_url = "https://rust-lang.github.io/libc/arm-unknown-linux-gnueabihf"
 ))]
 #![cfg_attr(all(target_os = "linux", target_arch = "mips"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/mips-unknown-linux-gnu"
+    html_root_url = "https://rust-lang.github.io/libc/mips-unknown-linux-gnu"
 ))]
 #![cfg_attr(all(target_os = "linux", target_arch = "aarch64"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/aarch64-unknown-linux-gnu"
+    html_root_url = "https://rust-lang.github.io/libc/aarch64-unknown-linux-gnu"
 ))]
 #![cfg_attr(all(target_os = "linux", target_env = "musl"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-unknown-linux-musl"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-unknown-linux-musl"
 ))]
 #![cfg_attr(all(target_os = "macos", target_arch = "x86_64"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-apple-darwin"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-apple-darwin"
 ))]
 #![cfg_attr(all(target_os = "macos", target_arch = "x86"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/i686-apple-darwin"
+    html_root_url = "https://rust-lang.github.io/libc/i686-apple-darwin"
 ))]
 #![cfg_attr(all(windows, target_arch = "x86_64", target_env = "gnu"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-pc-windows-gnu"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-pc-windows-gnu"
 ))]
 #![cfg_attr(all(windows, target_arch = "x86", target_env = "gnu"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/i686-pc-windows-gnu"
+    html_root_url = "https://rust-lang.github.io/libc/i686-pc-windows-gnu"
 ))]
 #![cfg_attr(all(windows, target_arch = "x86_64", target_env = "msvc"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-pc-windows-msvc"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-pc-windows-msvc"
 ))]
 #![cfg_attr(all(windows, target_arch = "x86", target_env = "msvc"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/i686-pc-windows-msvc"
+    html_root_url = "https://rust-lang.github.io/libc/i686-pc-windows-msvc"
 ))]
 #![cfg_attr(target_os = "android", doc(
-    html_root_url = "https://doc.rust-lang.org/libc/arm-linux-androideabi"
+    html_root_url = "https://rust-lang.github.io/libc/arm-linux-androideabi"
 ))]
 #![cfg_attr(target_os = "freebsd", doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-unknown-freebsd"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-unknown-freebsd"
 ))]
 #![cfg_attr(target_os = "openbsd", doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-unknown-openbsd"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-unknown-openbsd"
 ))]
 #![cfg_attr(target_os = "bitrig", doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-unknown-bitrig"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-unknown-bitrig"
 ))]
 #![cfg_attr(target_os = "netbsd", doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-unknown-netbsd"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-unknown-netbsd"
 ))]
 #![cfg_attr(target_os = "dragonfly", doc(
-    html_root_url = "https://doc.rust-lang.org/libc/x86_64-unknown-dragonfly"
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-unknown-dragonfly"
+))]
+#![cfg_attr(target_os = "solaris", doc(
+    html_root_url = "https://rust-lang.github.io/libc/x86_64-sun-solaris"
 ))]
 #![cfg_attr(all(target_os = "emscripten", target_arch = "asmjs"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/asmjs-unknown-emscripten"
+    html_root_url = "https://rust-lang.github.io/libc/asmjs-unknown-emscripten"
 ))]
 #![cfg_attr(all(target_os = "emscripten", target_arch = "wasm32"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/wasm32-unknown-emscripten"
+    html_root_url = "https://rust-lang.github.io/libc/wasm32-unknown-emscripten"
 ))]
-#![cfg_attr(all(target_os = "linux", target_arch = "xparc64"), doc(
-    html_root_url = "https://doc.rust-lang.org/libc/sparc64-unknown-linux-gnu"
+#![cfg_attr(all(target_os = "linux", target_arch = "sparc64"), doc(
+    html_root_url = "https://rust-lang.github.io/libc/sparc64-unknown-linux-gnu"
 ))]
 
 // Attributes needed when building as part of the standard library
-#![cfg_attr(feature = "stdbuild", feature(no_std, staged_api, custom_attribute, cfg_target_vendor))]
-#![cfg_attr(feature = "stdbuild", feature(link_cfg))]
-#![cfg_attr(feature = "stdbuild", no_std)]
-#![cfg_attr(feature = "stdbuild", staged_api)]
+#![cfg_attr(feature = "stdbuild", feature(staged_api, cfg_target_vendor))]
+#![cfg_attr(feature = "stdbuild", feature(link_cfg, repr_packed))]
 #![cfg_attr(feature = "stdbuild", allow(warnings))]
 #![cfg_attr(feature = "stdbuild", unstable(feature = "libc",
                                reason = "use `libc` from crates.io",
                                issue = "27783"))]
 
 #![cfg_attr(not(feature = "use_std"), no_std)]
 
-#[cfg(all(not(dox), feature = "use_std"))]
+#[cfg(all(not(cross_platform_docs), feature = "use_std"))]
 extern crate std as core;
 
 #[macro_use] mod macros;
 mod dox;
 
-// Use repr(u8) as LLVM expects `void*` to be the same as `i8*` to help enable
-// more optimization opportunities around it recognizing things like
-// malloc/free.
-#[repr(u8)]
-pub enum c_void {
-    // Two dummy variants so the #[repr] attribute can be used.
-    #[doc(hidden)]
-    __variant1,
-    #[doc(hidden)]
-    __variant2,
-}
+cfg_if! {
+    if #[cfg(all(target_arch = "wasm32", not(target_os = "emscripten")))] {
+        // empty ...
+    } else {
 
-pub type int8_t = i8;
-pub type int16_t = i16;
-pub type int32_t = i32;
-pub type int64_t = i64;
-pub type uint8_t = u8;
-pub type uint16_t = u16;
-pub type uint32_t = u32;
-pub type uint64_t = u64;
+        // Use repr(u8) as LLVM expects `void*` to be the same as `i8*` to help enable
+        // more optimization opportunities around it recognizing things like
+        // malloc/free.
+        #[repr(u8)]
+        pub enum c_void {
+            // Two dummy variants so the #[repr] attribute can be used.
+            #[doc(hidden)]
+            __variant1,
+            #[doc(hidden)]
+            __variant2,
+        }
 
-pub type c_schar = i8;
-pub type c_uchar = u8;
-pub type c_short = i16;
-pub type c_ushort = u16;
-pub type c_int = i32;
-pub type c_uint = u32;
-pub type c_float = f32;
-pub type c_double = f64;
-pub type c_longlong = i64;
-pub type c_ulonglong = u64;
-pub type intmax_t = i64;
-pub type uintmax_t = u64;
+        pub type int8_t = i8;
+        pub type int16_t = i16;
+        pub type int32_t = i32;
+        pub type int64_t = i64;
+        pub type uint8_t = u8;
+        pub type uint16_t = u16;
+        pub type uint32_t = u32;
+        pub type uint64_t = u64;
 
-pub type size_t = usize;
-pub type ptrdiff_t = isize;
-pub type intptr_t = isize;
-pub type uintptr_t = usize;
-pub type ssize_t = isize;
+        pub type c_schar = i8;
+        pub type c_uchar = u8;
+        pub type c_short = i16;
+        pub type c_ushort = u16;
+        pub type c_int = i32;
+        pub type c_uint = u32;
+        pub type c_float = f32;
+        pub type c_double = f64;
+        pub type c_longlong = i64;
+        pub type c_ulonglong = u64;
+        pub type intmax_t = i64;
+        pub type uintmax_t = u64;
 
-pub enum FILE {}
-pub enum fpos_t {} // TODO: fill this out with a struct
+        pub type size_t = usize;
+        pub type ptrdiff_t = isize;
+        pub type intptr_t = isize;
+        pub type uintptr_t = usize;
+        pub type ssize_t = isize;
 
-extern {
-    pub fn isalnum(c: c_int) -> c_int;
-    pub fn isalpha(c: c_int) -> c_int;
-    pub fn iscntrl(c: c_int) -> c_int;
-    pub fn isdigit(c: c_int) -> c_int;
-    pub fn isgraph(c: c_int) -> c_int;
-    pub fn islower(c: c_int) -> c_int;
-    pub fn isprint(c: c_int) -> c_int;
-    pub fn ispunct(c: c_int) -> c_int;
-    pub fn isspace(c: c_int) -> c_int;
-    pub fn isupper(c: c_int) -> c_int;
-    pub fn isxdigit(c: c_int) -> c_int;
-    pub fn tolower(c: c_int) -> c_int;
-    pub fn toupper(c: c_int) -> c_int;
+        pub enum FILE {}
+        pub enum fpos_t {} // TODO: fill this out with a struct
 
-    #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
-               link_name = "fopen$UNIX2003")]
-    pub fn fopen(filename: *const c_char,
-                 mode: *const c_char) -> *mut FILE;
-    #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
-               link_name = "freopen$UNIX2003")]
-    pub fn freopen(filename: *const c_char, mode: *const c_char,
-                   file: *mut FILE) -> *mut FILE;
-    pub fn fflush(file: *mut FILE) -> c_int;
-    pub fn fclose(file: *mut FILE) -> c_int;
-    pub fn remove(filename: *const c_char) -> c_int;
-    pub fn rename(oldname: *const c_char, newname: *const c_char) -> c_int;
-    pub fn tmpfile() -> *mut FILE;
-    pub fn setvbuf(stream: *mut FILE,
-                   buffer: *mut c_char,
-                   mode: c_int,
-                   size: size_t) -> c_int;
-    pub fn setbuf(stream: *mut FILE, buf: *mut c_char);
-    pub fn getchar() -> c_int;
-    pub fn putchar(c: c_int) -> c_int;
-    pub fn fgetc(stream: *mut FILE) -> c_int;
-    pub fn fgets(buf: *mut c_char, n: c_int, stream: *mut FILE) -> *mut c_char;
-    pub fn fputc(c: c_int, stream: *mut FILE) -> c_int;
-    #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
-               link_name = "fputs$UNIX2003")]
-    pub fn fputs(s: *const c_char, stream: *mut FILE)-> c_int;
-    pub fn puts(s: *const c_char) -> c_int;
-    pub fn ungetc(c: c_int, stream: *mut FILE) -> c_int;
-    pub fn fread(ptr: *mut c_void,
-                 size: size_t,
-                 nobj: size_t,
-                 stream: *mut FILE)
-                 -> size_t;
-    #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
-               link_name = "fwrite$UNIX2003")]
-    pub fn fwrite(ptr: *const c_void,
-                  size: size_t,
-                  nobj: size_t,
-                  stream: *mut FILE)
-                  -> size_t;
-    pub fn fseek(stream: *mut FILE, offset: c_long, whence: c_int) -> c_int;
-    pub fn ftell(stream: *mut FILE) -> c_long;
-    pub fn rewind(stream: *mut FILE);
-    #[cfg_attr(target_os = "netbsd", link_name = "__fgetpos50")]
-    pub fn fgetpos(stream: *mut FILE, ptr: *mut fpos_t) -> c_int;
-    #[cfg_attr(target_os = "netbsd", link_name = "__fsetpos50")]
-    pub fn fsetpos(stream: *mut FILE, ptr: *const fpos_t) -> c_int;
-    pub fn feof(stream: *mut FILE) -> c_int;
-    pub fn ferror(stream: *mut FILE) -> c_int;
-    pub fn perror(s: *const c_char);
-    pub fn atoi(s: *const c_char) -> c_int;
-    #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
-               link_name = "strtod$UNIX2003")]
-    pub fn strtod(s: *const c_char, endp: *mut *mut c_char) -> c_double;
-    pub fn strtol(s: *const c_char,
-                  endp: *mut *mut c_char, base: c_int) -> c_long;
-    pub fn strtoul(s: *const c_char, endp: *mut *mut c_char,
-                   base: c_int) -> c_ulong;
-    pub fn calloc(nobj: size_t, size: size_t) -> *mut c_void;
-    pub fn malloc(size: size_t) -> *mut c_void;
-    pub fn realloc(p: *mut c_void, size: size_t) -> *mut c_void;
-    pub fn free(p: *mut c_void);
-    pub fn abort() -> !;
-    pub fn exit(status: c_int) -> !;
-    pub fn _exit(status: c_int) -> !;
-    pub fn atexit(cb: extern fn()) -> c_int;
-    #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
-               link_name = "system$UNIX2003")]
-    pub fn system(s: *const c_char) -> c_int;
-    pub fn getenv(s: *const c_char) -> *mut c_char;
+        pub const INT_MIN: c_int = -2147483648;
+        pub const INT_MAX: c_int = 2147483647;
 
-    pub fn strcpy(dst: *mut c_char, src: *const c_char) -> *mut c_char;
-    pub fn strncpy(dst: *mut c_char, src: *const c_char, n: size_t)
-                   -> *mut c_char;
-    pub fn strcat(s: *mut c_char, ct: *const c_char) -> *mut c_char;
-    pub fn strncat(s: *mut c_char, ct: *const c_char, n: size_t) -> *mut c_char;
-    pub fn strcmp(cs: *const c_char, ct: *const c_char) -> c_int;
-    pub fn strncmp(cs: *const c_char, ct: *const c_char, n: size_t) -> c_int;
-    pub fn strcoll(cs: *const c_char, ct: *const c_char) -> c_int;
-    pub fn strchr(cs: *const c_char, c: c_int) -> *mut c_char;
-    pub fn strrchr(cs: *const c_char, c: c_int) -> *mut c_char;
-    pub fn strspn(cs: *const c_char, ct: *const c_char) -> size_t;
-    pub fn strcspn(cs: *const c_char, ct: *const c_char) -> size_t;
-    pub fn strdup(cs: *const c_char) -> *mut c_char;
-    pub fn strpbrk(cs: *const c_char, ct: *const c_char) -> *mut c_char;
-    pub fn strstr(cs: *const c_char, ct: *const c_char) -> *mut c_char;
-    pub fn strlen(cs: *const c_char) -> size_t;
-    pub fn strnlen(cs: *const c_char, maxlen: size_t) -> size_t;
-    #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
-               link_name = "strerror$UNIX2003")]
-    pub fn strerror(n: c_int) -> *mut c_char;
-    pub fn strtok(s: *mut c_char, t: *const c_char) -> *mut c_char;
-    pub fn strxfrm(s: *mut c_char, ct: *const c_char, n: size_t) -> size_t;
-    pub fn wcslen(buf: *const wchar_t) -> size_t;
-    pub fn wcstombs(dest: *mut c_char, src: *const wchar_t, n: size_t) -> ::size_t;
+        extern {
+            pub fn isalnum(c: c_int) -> c_int;
+            pub fn isalpha(c: c_int) -> c_int;
+            pub fn iscntrl(c: c_int) -> c_int;
+            pub fn isdigit(c: c_int) -> c_int;
+            pub fn isgraph(c: c_int) -> c_int;
+            pub fn islower(c: c_int) -> c_int;
+            pub fn isprint(c: c_int) -> c_int;
+            pub fn ispunct(c: c_int) -> c_int;
+            pub fn isspace(c: c_int) -> c_int;
+            pub fn isupper(c: c_int) -> c_int;
+            pub fn isxdigit(c: c_int) -> c_int;
+            pub fn tolower(c: c_int) -> c_int;
+            pub fn toupper(c: c_int) -> c_int;
 
-    pub fn memchr(cx: *const c_void, c: c_int, n: size_t) -> *mut c_void;
-    pub fn memcmp(cx: *const c_void, ct: *const c_void, n: size_t) -> c_int;
-    pub fn memcpy(dest: *mut c_void, src: *const c_void, n: size_t) -> *mut c_void;
-    pub fn memmove(dest: *mut c_void, src: *const c_void, n: size_t) -> *mut c_void;
-    pub fn memset(dest: *mut c_void, c: c_int, n: size_t) -> *mut c_void;
-}
+            #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
+                       link_name = "fopen$UNIX2003")]
+            pub fn fopen(filename: *const c_char,
+                         mode: *const c_char) -> *mut FILE;
+            #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
+                       link_name = "freopen$UNIX2003")]
+            pub fn freopen(filename: *const c_char, mode: *const c_char,
+                           file: *mut FILE) -> *mut FILE;
+            pub fn fflush(file: *mut FILE) -> c_int;
+            pub fn fclose(file: *mut FILE) -> c_int;
+            pub fn remove(filename: *const c_char) -> c_int;
+            pub fn rename(oldname: *const c_char, newname: *const c_char) -> c_int;
+            pub fn tmpfile() -> *mut FILE;
+            pub fn setvbuf(stream: *mut FILE,
+                           buffer: *mut c_char,
+                           mode: c_int,
+                           size: size_t) -> c_int;
+            pub fn setbuf(stream: *mut FILE, buf: *mut c_char);
+            pub fn getchar() -> c_int;
+            pub fn putchar(c: c_int) -> c_int;
+            pub fn fgetc(stream: *mut FILE) -> c_int;
+            pub fn fgets(buf: *mut c_char, n: c_int, stream: *mut FILE) -> *mut c_char;
+            pub fn fputc(c: c_int, stream: *mut FILE) -> c_int;
+            #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
+                       link_name = "fputs$UNIX2003")]
+            pub fn fputs(s: *const c_char, stream: *mut FILE)-> c_int;
+            pub fn puts(s: *const c_char) -> c_int;
+            pub fn ungetc(c: c_int, stream: *mut FILE) -> c_int;
+            pub fn fread(ptr: *mut c_void,
+                         size: size_t,
+                         nobj: size_t,
+                         stream: *mut FILE)
+                         -> size_t;
+            #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
+                       link_name = "fwrite$UNIX2003")]
+            pub fn fwrite(ptr: *const c_void,
+                          size: size_t,
+                          nobj: size_t,
+                          stream: *mut FILE)
+                          -> size_t;
+            pub fn fseek(stream: *mut FILE, offset: c_long, whence: c_int) -> c_int;
+            pub fn ftell(stream: *mut FILE) -> c_long;
+            pub fn rewind(stream: *mut FILE);
+            #[cfg_attr(target_os = "netbsd", link_name = "__fgetpos50")]
+            pub fn fgetpos(stream: *mut FILE, ptr: *mut fpos_t) -> c_int;
+            #[cfg_attr(target_os = "netbsd", link_name = "__fsetpos50")]
+            pub fn fsetpos(stream: *mut FILE, ptr: *const fpos_t) -> c_int;
+            pub fn feof(stream: *mut FILE) -> c_int;
+            pub fn ferror(stream: *mut FILE) -> c_int;
+            pub fn perror(s: *const c_char);
+            pub fn atoi(s: *const c_char) -> c_int;
+            #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
+                       link_name = "strtod$UNIX2003")]
+            pub fn strtod(s: *const c_char, endp: *mut *mut c_char) -> c_double;
+            pub fn strtol(s: *const c_char,
+                          endp: *mut *mut c_char, base: c_int) -> c_long;
+            pub fn strtoul(s: *const c_char, endp: *mut *mut c_char,
+                           base: c_int) -> c_ulong;
+            pub fn calloc(nobj: size_t, size: size_t) -> *mut c_void;
+            pub fn malloc(size: size_t) -> *mut c_void;
+            pub fn realloc(p: *mut c_void, size: size_t) -> *mut c_void;
+            pub fn free(p: *mut c_void);
+            pub fn abort() -> !;
+            pub fn exit(status: c_int) -> !;
+            pub fn _exit(status: c_int) -> !;
+            pub fn atexit(cb: extern fn()) -> c_int;
+            #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
+                       link_name = "system$UNIX2003")]
+            pub fn system(s: *const c_char) -> c_int;
+            pub fn getenv(s: *const c_char) -> *mut c_char;
+
+            pub fn strcpy(dst: *mut c_char, src: *const c_char) -> *mut c_char;
+            pub fn strncpy(dst: *mut c_char, src: *const c_char, n: size_t)
+                           -> *mut c_char;
+            pub fn strcat(s: *mut c_char, ct: *const c_char) -> *mut c_char;
+            pub fn strncat(s: *mut c_char, ct: *const c_char, n: size_t) -> *mut c_char;
+            pub fn strcmp(cs: *const c_char, ct: *const c_char) -> c_int;
+            pub fn strncmp(cs: *const c_char, ct: *const c_char, n: size_t) -> c_int;
+            pub fn strcoll(cs: *const c_char, ct: *const c_char) -> c_int;
+            pub fn strchr(cs: *const c_char, c: c_int) -> *mut c_char;
+            pub fn strrchr(cs: *const c_char, c: c_int) -> *mut c_char;
+            pub fn strspn(cs: *const c_char, ct: *const c_char) -> size_t;
+            pub fn strcspn(cs: *const c_char, ct: *const c_char) -> size_t;
+            pub fn strdup(cs: *const c_char) -> *mut c_char;
+            pub fn strpbrk(cs: *const c_char, ct: *const c_char) -> *mut c_char;
+            pub fn strstr(cs: *const c_char, ct: *const c_char) -> *mut c_char;
+            pub fn strlen(cs: *const c_char) -> size_t;
+            pub fn strnlen(cs: *const c_char, maxlen: size_t) -> size_t;
+            #[cfg_attr(all(target_os = "macos", target_arch = "x86"),
+                       link_name = "strerror$UNIX2003")]
+            pub fn strerror(n: c_int) -> *mut c_char;
+            pub fn strtok(s: *mut c_char, t: *const c_char) -> *mut c_char;
+            pub fn strxfrm(s: *mut c_char, ct: *const c_char, n: size_t) -> size_t;
+            pub fn wcslen(buf: *const wchar_t) -> size_t;
+            pub fn wcstombs(dest: *mut c_char, src: *const wchar_t, n: size_t) -> ::size_t;
 
-// These are all inline functions on android, so they end up just being entirely
-// missing on that platform.
-#[cfg(not(target_os = "android"))]
-extern {
-    pub fn abs(i: c_int) -> c_int;
-    pub fn atof(s: *const c_char) -> c_double;
-    pub fn labs(i: c_long) -> c_long;
-    pub fn rand() -> c_int;
-    pub fn srand(seed: c_uint);
+            pub fn memchr(cx: *const c_void, c: c_int, n: size_t) -> *mut c_void;
+            pub fn memcmp(cx: *const c_void, ct: *const c_void, n: size_t) -> c_int;
+            pub fn memcpy(dest: *mut c_void, src: *const c_void, n: size_t) -> *mut c_void;
+            pub fn memmove(dest: *mut c_void, src: *const c_void, n: size_t) -> *mut c_void;
+            pub fn memset(dest: *mut c_void, c: c_int, n: size_t) -> *mut c_void;
+        }
+
+        // These are all inline functions on android, so they end up just being entirely
+        // missing on that platform.
+        #[cfg(not(target_os = "android"))]
+        extern {
+            pub fn abs(i: c_int) -> c_int;
+            pub fn atof(s: *const c_char) -> c_double;
+            pub fn labs(i: c_long) -> c_long;
+            pub fn rand() -> c_int;
+            pub fn srand(seed: c_uint);
+        }
+    }
 }
 
 cfg_if! {
     if #[cfg(windows)] {
         mod windows;
         pub use windows::*;
     } else if #[cfg(target_os = "redox")] {
         mod redox;
         pub use redox::*;
+    } else if #[cfg(target_os = "cloudabi")] {
+        mod cloudabi;
+        pub use cloudabi::*;
+    } else if #[cfg(target_os = "fuchsia")] {
+        mod fuchsia;
+        pub use fuchsia::*;
     } else if #[cfg(unix)] {
         mod unix;
         pub use unix::*;
     } else {
         // Unknown target_family
     }
 }
diff --git a/third_party/rust/libc/src/macros.rs b/third_party/rust/libc/src/macros.rs
index 842944201441..f48ad45941f6 100644
--- a/third_party/rust/libc/src/macros.rs
+++ b/third_party/rust/libc/src/macros.rs
@@ -30,42 +30,59 @@ macro_rules! __cfg_if_items {
 
 macro_rules! __cfg_if_apply {
     ($m:meta, $($it:item)*) => {
         $(#[$m] $it)*
     }
 }
 
 macro_rules! s {
-    ($($(#[$attr:meta])* pub struct $i:ident { $($field:tt)* })*) => ($(
+    ($($(#[$attr:meta])* pub $t:ident $i:ident { $($field:tt)* })*) => ($(
         __item! {
             #[repr(C)]
             $(#[$attr])*
-            pub struct $i { $($field)* }
+            pub $t $i { $($field)* }
         }
         impl ::dox::Copy for $i {}
         impl ::dox::Clone for $i {
             fn clone(&self) -> $i { *self }
         }
     )*)
 }
 
 macro_rules! f {
     ($(pub fn $i:ident($($arg:ident: $argty:ty),*) -> $ret:ty {
         $($body:stmt);*
     })*) => ($(
         #[inline]
-        #[cfg(not(dox))]
+        #[cfg(not(cross_platform_docs))]
         pub unsafe extern fn $i($($arg: $argty),*) -> $ret {
             $($body);*
         }
 
-        #[cfg(dox)]
+        #[cfg(cross_platform_docs)]
         #[allow(dead_code)]
         pub unsafe extern fn $i($($arg: $argty),*) -> $ret {
             loop {}
         }
     )*)
 }
 
 macro_rules! __item {
     ($i:item) => ($i)
 }
+
+#[allow(unused_macros)]
+macro_rules! align_const {
+    ($($(#[$attr:meta])* pub const $name:ident : $t1:ty = $t2:ident { $($field:tt)* };)*) => ($(
+        #[cfg(feature = "align")]
+        $(#[$attr])*
+        pub const $name : $t1 = $t2 {
+            $($field)*
+        };
+        #[cfg(not(feature = "align"))]
+        $(#[$attr])*
+        pub const $name : $t1 = $t2 {
+            $($field)*
+            __align: [],
+        };
+    )*)
+}
diff --git a/third_party/rust/libc/src/redox/mod.rs b/third_party/rust/libc/src/redox/mod.rs
index 82b296f96553..e32c4b385b17 100644
--- a/third_party/rust/libc/src/redox/mod.rs
+++ b/third_party/rust/libc/src/redox/mod.rs
@@ -80,17 +80,51 @@ pub const O_CREAT: ::c_int =      0x0200_0000;
 pub const O_TRUNC: ::c_int =      0x0400_0000;
 pub const O_EXCL: ::c_int =       0x0800_0000;
 pub const O_DIRECTORY: ::c_int =  0x1000_0000;
 pub const O_STAT: ::c_int =       0x2000_0000;
 pub const O_SYMLINK: ::c_int =    0x4000_0000;
 pub const O_NOFOLLOW: ::c_int =   0x8000_0000;
 pub const O_ACCMODE: ::c_int =    O_RDONLY | O_WRONLY | O_RDWR;
 
+pub const SIGHUP:    ::c_int = 1;
+pub const SIGINT:    ::c_int = 2;
+pub const SIGQUIT:   ::c_int = 3;
+pub const SIGILL:    ::c_int = 4;
+pub const SIGTRAP:   ::c_int = 5;
+pub const SIGABRT:   ::c_int = 6;
+pub const SIGBUS:    ::c_int = 7;
+pub const SIGFPE:    ::c_int = 8;
+pub const SIGKILL:   ::c_int = 9;
+pub const SIGUSR1:   ::c_int = 10;
+pub const SIGSEGV:   ::c_int = 11;
+pub const SIGUSR2:   ::c_int = 12;
+pub const SIGPIPE:   ::c_int = 13;
+pub const SIGALRM:   ::c_int = 14;
+pub const SIGTERM:   ::c_int = 15;
+pub const SIGSTKFLT: ::c_int = 16;
+pub const SIGCHLD:   ::c_int = 17;
+pub const SIGCONT:   ::c_int = 18;
+pub const SIGSTOP:   ::c_int = 19;
+pub const SIGTSTP:   ::c_int = 20;
+pub const SIGTTIN:   ::c_int = 21;
+pub const SIGTTOU:   ::c_int = 22;
+pub const SIGURG:    ::c_int = 23;
+pub const SIGXCPU:   ::c_int = 24;
+pub const SIGXFSZ:   ::c_int = 25;
+pub const SIGVTALRM: ::c_int = 26;
+pub const SIGPROF:   ::c_int = 27;
+pub const SIGWINCH:  ::c_int = 28;
+pub const SIGIO:     ::c_int = 29;
+pub const SIGPWR:    ::c_int = 30;
+pub const SIGSYS:    ::c_int = 31;
+
 extern {
+    pub fn gethostname(name: *mut ::c_char, len: ::size_t) -> ::c_int;
+    pub fn getpid() -> pid_t;
     pub fn memalign(align: ::size_t, size: ::size_t) -> *mut ::c_void;
     pub fn read(fd: ::c_int, buf: *mut ::c_void, count: ::size_t)
                 -> ::ssize_t;
     pub fn write(fd: ::c_int, buf: *const ::c_void, count: ::size_t)
                  -> ::ssize_t;
     pub fn fcntl(fd: ::c_int, cmd: ::c_int, ...) -> ::c_int;
     pub fn close(fd: ::c_int) -> ::c_int;
 }
diff --git a/third_party/rust/libc/src/redox/net.rs b/third_party/rust/libc/src/redox/net.rs
index 091691643014..fcbb181c3297 100644
--- a/third_party/rust/libc/src/redox/net.rs
+++ b/third_party/rust/libc/src/redox/net.rs
@@ -4,18 +4,20 @@ pub type in_port_t = u16;
 pub type socklen_t = u32;
 pub type sa_family_t = u16;
 
 s! {
     pub struct in_addr {
         pub s_addr: in_addr_t,
     }
 
+    #[cfg_attr(feature = "align", repr(align(4)))]
     pub struct in6_addr {
         pub s6_addr: [u8; 16],
+        #[cfg(not(feature = "align"))]
         __align: [u32; 0],
     }
 
     pub struct ip_mreq {
         pub imr_multiaddr: in_addr,
         pub imr_interface: in_addr,
     }
 
@@ -102,9 +104,21 @@ extern {
     pub fn getsockopt(sockfd: ::c_int,
                       level: ::c_int,
                       optname: ::c_int,
                       optval: *mut ::c_void,
                       optlen: *mut ::socklen_t) -> ::c_int;
     pub fn setsockopt(socket: ::c_int, level: ::c_int, name: ::c_int,
                       value: *const ::c_void,
                       option_len: socklen_t) -> ::c_int;
+    pub fn getpeername(socket: ::c_int, address: *mut sockaddr,
+                       address_len: *mut socklen_t) -> ::c_int;
+    pub fn sendto(socket: ::c_int, buf: *const ::c_void, len: ::size_t,
+                  flags: ::c_int, addr: *const sockaddr,
+                  addrlen: socklen_t) -> ::ssize_t;
+    pub fn send(socket: ::c_int, buf: *const ::c_void, len: ::size_t,
+                flags: ::c_int) -> ::ssize_t;
+    pub fn recvfrom(socket: ::c_int, buf: *mut ::c_void, len: ::size_t,
+                    flags: ::c_int, addr: *mut ::sockaddr,
+                    addrlen: *mut ::socklen_t) -> ::ssize_t;
+    pub fn recv(socket: ::c_int, buf: *mut ::c_void, len: ::size_t,
+                flags: ::c_int) -> ::ssize_t;
 }
diff --git a/third_party/rust/libc/src/unix/bsd/apple/b32.rs b/third_party/rust/libc/src/unix/bsd/apple/b32.rs
index 53fc0ae19df1..5dea472ccb6b 100644
--- a/third_party/rust/libc/src/unix/bsd/apple/b32.rs
+++ b/third_party/rust/libc/src/unix/bsd/apple/b32.rs
@@ -36,16 +36,23 @@ s! {
         pub ifi_recvtiming: u32,
         pub ifi_xmittiming: u32,
         pub ifi_lastchange: ::timeval,
         pub ifi_unused2: u32,
         pub ifi_hwassist: u32,
         pub ifi_reserved1: u32,
         pub ifi_reserved2: u32,
     }
+
+    pub struct bpf_hdr {
+        pub bh_tstamp: ::timeval,
+        pub bh_caplen: ::uint32_t,
+        pub bh_datalen: ::uint32_t,
+        pub bh_hdrlen: ::c_ushort,
+    }
 }
 
 pub const __PTHREAD_MUTEX_SIZE__: usize = 40;
 pub const __PTHREAD_COND_SIZE__: usize = 24;
 pub const __PTHREAD_CONDATTR_SIZE__: usize = 4;
 pub const __PTHREAD_RWLOCK_SIZE__: usize = 124;
 pub const __PTHREAD_RWLOCKATTR_SIZE__: usize = 12;
 
diff --git a/third_party/rust/libc/src/unix/bsd/apple/b64.rs b/third_party/rust/libc/src/unix/bsd/apple/b64.rs
index e4a398194128..ca98f2095236 100644
--- a/third_party/rust/libc/src/unix/bsd/apple/b64.rs
+++ b/third_party/rust/libc/src/unix/bsd/apple/b64.rs
@@ -41,20 +41,25 @@ s! {
         pub ifi_recvtiming: u32,
         pub ifi_xmittiming: u32,
         pub ifi_lastchange: timeval32,
         pub ifi_unused2: u32,
         pub ifi_hwassist: u32,
         pub ifi_reserved1: u32,
         pub ifi_reserved2: u32,
     }
+
+    pub struct bpf_hdr {
+        pub bh_tstamp: ::timeval32,
+        pub bh_caplen: ::uint32_t,
+        pub bh_datalen: ::uint32_t,
+        pub bh_hdrlen: ::c_ushort,
+    }
 }
 
 pub const __PTHREAD_MUTEX_SIZE__: usize = 56;
 pub const __PTHREAD_COND_SIZE__: usize = 40;
 pub const __PTHREAD_CONDATTR_SIZE__: usize = 8;
 pub const __PTHREAD_RWLOCK_SIZE__: usize = 192;
 pub const __PTHREAD_RWLOCKATTR_SIZE__: usize = 16;
 
 pub const TIOCTIMESTAMP: ::c_ulong = 0x40107459;
 pub const TIOCDCDTIMESTAMP: ::c_ulong = 0x40107458;
-
-pub const FIONREAD: ::c_ulong = 0x4004667f;
